from rest_framework import generics
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework import status

from .models import Home, Group_member, Presentation, File
from .serializers import HomeSerializer, Group_membarSerializer, PresentationSerializer, ContractSerializer

class HomePageView(generics.ListAPIView):
    queryset = Home.objects.all()
    serializer_class = HomeSerializer

    def list(self, request, *args, **kwargs):
        queryset = self.get_queryset()
        videos = queryset.filter(media_type='video')
        images = queryset.filter(media_type='photo')
        if videos.exists():
            serializer = self.get_serializer(videos, many=True)
        else:
            serializer = self.get_serializer(images, many=True)
        return Response(serializer.data)


class GroupMemberListView(generics.ListAPIView):
    queryset = Group_member.objects.all()
    serializer_class = Group_membarSerializer


class PresentationListView(generics.ListAPIView):
    queryset = Presentation.objects.all()
    serializer_class = PresentationSerializer

class ContractCreateAPIView(APIView):
    def post(self, request):
        serializer = ContractSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data, status=status.HTTP_201_CREATED)
        return Response(serializer.errors, status=status.HTTP_400_BAD_REQUEST)
